Index: kern/kern_clock.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_clock.c,v
retrieving revision 1.14
diff -u -r1.14 kern_clock.c
--- kern/kern_clock.c	7 Jan 2004 20:21:46 -0000	1.14
+++ kern/kern_clock.c	27 Jan 2004 23:01:05 -0000
@@ -574,395 +608,163 @@
  * which is as precise as possible.  The "up" variants return the
  * time relative to system boot, these are well suited for time
  * interval measurements.
+ *
+ * Each cpu independantly maintains the current time of day, so all
+ * we need to do to protect ourselves from changes is to do a loop
+ * check on the seconds field changing out from under us.
  */
-
 void
-getmicrotime(struct timeval *tvp)
+getmicrouptime(struct timeval *tvp)
 {
-	struct timecounter *tc;
+	struct globaldata *gd = mycpu;
+	sysclock_t delta;
 
-	if (!tco_method) {
-		tc = timecounter;
-		*tvp = tc->tc_microtime;
-	} else {
-		microtime(tvp);
+	do {
+		tvp->tv_sec = gd->gd_time_seconds;
+		delta = gd->gd_hardclock.time - gd->gd_cpuclock_base;
+	} while (tvp->tv_sec != gd->gd_time_seconds);
+	tvp->tv_usec = (cputimer_freq64_usec * delta) >> 32;
+	if (tvp->tv_usec >= 1000000) {
+		tvp->tv_usec -= 1000000;
+		++tvp->tv_sec;
 	}
 }
 
 void
-getnanotime(struct timespec *tsp)
+getnanouptime(struct timespec *tsp)
 {
-	struct timecounter *tc;
+	struct globaldata *gd = mycpu;
+	sysclock_t delta;
 
-	if (!tco_method) {
-		tc = timecounter;
-		*tsp = tc->tc_nanotime;
-	} else {
-		nanotime(tsp);
+	do {
+		tsp->tv_sec = gd->gd_time_seconds;
+		delta = gd->gd_hardclock.time - gd->gd_cpuclock_base;
+	} while (tsp->tv_sec != gd->gd_time_seconds);
+	tsp->tv_nsec = (cputimer_freq64_nsec * delta) >> 32;
+	if (tsp->tv_nsec >= 1000000000) {
+		tsp->tv_nsec -= 1000000000;
+		++tsp->tv_sec;
 	}
 }
 
 void
-microtime(struct timeval *tv)
+microuptime(struct timeval *tvp)
 {
-	struct timecounter *tc;
-	int delta;
+	struct globaldata *gd = mycpu;
+	sysclock_t delta;
 
-	tc = timecounter;
-	crit_enter();
-	delta = tco_delta(tc);
-	tv->tv_sec = tc->tc_offset_sec;
-	tv->tv_usec = tc->tc_offset_micro;
-	tv->tv_usec += ((u_int64_t)delta * tc->tc_scale_micro) >> 32;
-	crit_exit();
-	tv->tv_usec += boottime.tv_usec;
-	tv->tv_sec += boottime.tv_sec;
-	while (tv->tv_usec < 0) {
-		tv->tv_usec += 1000000;
-		if (tv->tv_sec > 0)
-			tv->tv_sec--;
-	}
-	while (tv->tv_usec >= 1000000) {
-		tv->tv_usec -= 1000000;
-		tv->tv_sec++;
+	do {
+		tvp->tv_sec = gd->gd_time_seconds;
+		delta = cputimer_count() - gd->gd_cpuclock_base;
+	} while (tvp->tv_sec != gd->gd_time_seconds);
+	tvp->tv_usec = (cputimer_freq64_usec * delta) >> 32;
+	if (tvp->tv_usec >= 1000000) {
+		tvp->tv_usec -= 1000000;
+		++tvp->tv_sec;
 	}
 }
 
 void
-nanotime(struct timespec *ts)
+nanouptime(struct timespec *tsp)
 {
-	unsigned count;
-	u_int64_t delta;
-	struct timecounter *tc;
+	struct globaldata *gd = mycpu;
+	sysclock_t delta;
 
-	tc = timecounter;
-	crit_enter();
-	ts->tv_sec = tc->tc_offset_sec;
-	count = tco_delta(tc);
-	delta = tc->tc_offset_nano;
-	crit_exit();
-	delta += ((u_int64_t)count * tc->tc_scale_nano_f);
-	delta >>= 32;
-	delta += ((u_int64_t)count * tc->tc_scale_nano_i);
-	delta += boottime.tv_usec * 1000;
-	ts->tv_sec += boottime.tv_sec;
-	while (delta < 0) {
-		delta += 1000000000;
-		if (ts->tv_sec > 0)
-			ts->tv_sec--;
-	}
-	while (delta >= 1000000000) {
-		delta -= 1000000000;
-		ts->tv_sec++;
+	do {
+		tsp->tv_sec = gd->gd_time_seconds;
+		delta = cputimer_count() - gd->gd_cpuclock_base;
+	} while (tsp->tv_sec != gd->gd_time_seconds);
+	tsp->tv_nsec = (cputimer_freq64_nsec * delta) >> 32;
+	if (tsp->tv_nsec >= 1000000000) {
+		tsp->tv_nsec -= 1000000000;
+		++tsp->tv_sec;
 	}
-	ts->tv_nsec = delta;
 }
 
-void
-getmicrouptime(struct timeval *tvp)
-{
-	struct timecounter *tc;
-
-	if (!tco_method) {
-		tc = timecounter;
-		tvp->tv_sec = tc->tc_offset_sec;
-		tvp->tv_usec = tc->tc_offset_micro;
-	} else {
-		microuptime(tvp);
-	}
-}
+/*
+ * realtime routines
+ */
 
 void
-getnanouptime(struct timespec *tsp)
+getmicrotime(struct timeval *tvp)
 {
-	struct timecounter *tc;
+	struct globaldata *gd = mycpu;
+	sysclock_t delta;
 
-	if (!tco_method) {
-		tc = timecounter;
-		tsp->tv_sec = tc->tc_offset_sec;
-		tsp->tv_nsec = tc->tc_offset_nano >> 32;
-	} else {
-		nanouptime(tsp);
+	do {
+		tvp->tv_sec = gd->gd_time_seconds;
+		delta = gd->gd_hardclock.time - gd->gd_cpuclock_base;
+	} while (tvp->tv_sec != gd->gd_time_seconds);
+	tvp->tv_usec = (cputimer_freq64_usec * delta) >> 32;
+
+	tvp->tv_sec += basetime.tv_sec;
+	tvp->tv_usec += basetime.tv_nsec / 1000;
+	while (tvp->tv_usec >= 1000000) {
+		tvp->tv_usec -= 1000000;
+		++tvp->tv_sec;
 	}
 }
 
 void
-microuptime(struct timeval *tv)
+getnanotime(struct timespec *tsp)
 {
-	struct timecounter *tc;
+	struct globaldata *gd = mycpu;
+	sysclock_t delta;
 
-	tc = timecounter;
-	tv->tv_sec = tc->tc_offset_sec;
-	tv->tv_usec = tc->tc_offset_micro;
-	tv->tv_usec += ((u_int64_t)tco_delta(tc) * tc->tc_scale_micro) >> 32;
-	while (tv->tv_usec < 0) {
-		tv->tv_usec += 1000000;
-		if (tv->tv_sec > 0)
-			tv->tv_sec--;
-	}
-	while (tv->tv_usec >= 1000000) {
-		tv->tv_usec -= 1000000;
-		tv->tv_sec++;
-	}
-}
+	do {
+		tsp->tv_sec = gd->gd_time_seconds;
+		delta = gd->gd_hardclock.time - gd->gd_cpuclock_base;
+	} while (tsp->tv_sec != gd->gd_time_seconds);
+	tsp->tv_nsec = (cputimer_freq64_nsec * delta) >> 32;
 
-void
-nanouptime(struct timespec *ts)
-{
-	unsigned count;
-	u_int64_t delta;
-	struct timecounter *tc;
-
-	tc = timecounter;
-	ts->tv_sec = tc->tc_offset_sec;
-	count = tco_delta(tc);
-	delta = tc->tc_offset_nano;
-	delta += ((u_int64_t)count * tc->tc_scale_nano_f);
-	delta >>= 32;
-	delta += ((u_int64_t)count * tc->tc_scale_nano_i);
-	while (delta < 0) {
-		delta += 1000000000;
-		if (ts->tv_sec > 0)
-			ts->tv_sec--;
-	}
-	while (delta >= 1000000000) {
-		delta -= 1000000000;
-		ts->tv_sec++;
+	tsp->tv_sec += basetime.tv_sec;
+	tsp->tv_nsec += basetime.tv_nsec;
+	while (tsp->tv_nsec >= 1000000000) {
+		tsp->tv_nsec -= 1000000000;
+		++tsp->tv_sec;
 	}
-	ts->tv_nsec = delta;
-}
-
-static void
-tco_setscales(struct timecounter *tc)
-{
-	u_int64_t scale;
-
-	scale = 1000000000LL << 32;
-	scale += tc->tc_adjustment;
-	scale /= tc->tc_tweak->tc_frequency;
-	tc->tc_scale_micro = scale / 1000;
-	tc->tc_scale_nano_f = scale & 0xffffffff;
-	tc->tc_scale_nano_i = scale >> 32;
 }
 
 void
-update_timecounter(struct timecounter *tc)
+microtime(struct timeval *tvp)
 {
-	tco_setscales(tc);
-}
+	struct globaldata *gd = mycpu;
+	sysclock_t delta;
 
-void
-init_timecounter(struct timecounter *tc)
-{
-	struct timespec ts1;
-	struct timecounter *t1, *t2, *t3;
-	unsigned u;
-	int i;
+	do {
+		tvp->tv_sec = gd->gd_time_seconds;
+		delta = cputimer_count() - gd->gd_cpuclock_base;
+	} while (tvp->tv_sec != gd->gd_time_seconds);
+	tvp->tv_usec = (cputimer_freq64_usec * delta) >> 32;
 
-	u = tc->tc_frequency / tc->tc_counter_mask;
-	if (u > hz) {
-		printf("Timecounter \"%s\" frequency %lu Hz"
-		       " -- Insufficient hz, needs at least %u\n",
-		       tc->tc_name, (u_long) tc->tc_frequency, u);
-		return;
+	tvp->tv_sec += basetime.tv_sec;
+	tvp->tv_usec += basetime.tv_nsec / 1000;
+	while (tvp->tv_usec >= 1000000) {
+		tvp->tv_usec -= 1000000;
+		++tvp->tv_sec;
 	}
-
-	tc->tc_adjustment = 0;
-	tc->tc_tweak = tc;
-	tco_setscales(tc);
-	tc->tc_offset_count = tc->tc_get_timecount(tc);
-	if (timecounter == &dummy_timecounter)
-		tc->tc_avail = tc;
-	else {
-		tc->tc_avail = timecounter->tc_tweak->tc_avail;
-		timecounter->tc_tweak->tc_avail = tc;
-	}
-	MALLOC(t1, struct timecounter *, sizeof *t1, M_TIMECOUNTER, M_WAITOK);
-	tc->tc_other = t1;
-	*t1 = *tc;
-	t2 = t1;
-	for (i = 1; i < NTIMECOUNTER; i++) {
-		MALLOC(t3, struct timecounter *, sizeof *t3,
-		    M_TIMECOUNTER, M_WAITOK);
-		*t3 = *tc;
-		t3->tc_other = t2;
-		t2 = t3;
-	}
-	t1->tc_other = t3;
-	tc = t1;
-
-	printf("Timecounter \"%s\"  frequency %lu Hz\n", 
-	    tc->tc_name, (u_long)tc->tc_frequency);
-
-	/* XXX: For now always start using the counter. */
-	tc->tc_offset_count = tc->tc_get_timecount(tc);
-	nanouptime(&ts1);
-	tc->tc_offset_nano = (u_int64_t)ts1.tv_nsec << 32;
-	tc->tc_offset_micro = ts1.tv_nsec / 1000;
-	tc->tc_offset_sec = ts1.tv_sec;
-	timecounter = tc;
 }
 
 void
-set_timecounter(struct timespec *ts)
+nanotime(struct timespec *tsp)
 {
-	struct timespec ts2;
-
-	nanouptime(&ts2);
-	boottime.tv_sec = ts->tv_sec - ts2.tv_sec;
-	boottime.tv_usec = (ts->tv_nsec - ts2.tv_nsec) / 1000;
-	if (boottime.tv_usec < 0) {
-		boottime.tv_usec += 1000000;
-		boottime.tv_sec--;
-	}
-	/* fiddle all the little crinkly bits around the fiords... */
-	tco_forward(1);
-}
-
-static void
-switch_timecounter(struct timecounter *newtc)
-{
-	int s;
-	struct timecounter *tc;
-	struct timespec ts;
-
-	s = splclock();
-	tc = timecounter;
-	if (newtc->tc_tweak == tc->tc_tweak) {
-		splx(s);
-		return;
-	}
-	newtc = newtc->tc_tweak->tc_other;
-	nanouptime(&ts);
-	newtc->tc_offset_sec = ts.tv_sec;
-	newtc->tc_offset_nano = (u_int64_t)ts.tv_nsec << 32;
-	newtc->tc_offset_micro = ts.tv_nsec / 1000;
-	newtc->tc_offset_count = newtc->tc_get_timecount(newtc);
-	tco_setscales(newtc);
-	timecounter = newtc;
-	splx(s);
-}
-
-static struct timecounter *
-sync_other_counter(void)
-{
-	struct timecounter *tc, *tcn, *tco;
-	unsigned delta;
-
-	tco = timecounter;
-	tc = tco->tc_other;
-	tcn = tc->tc_other;
-	*tc = *tco;
-	tc->tc_other = tcn;
-	delta = tco_delta(tc);
-	tc->tc_offset_count += delta;
-	tc->tc_offset_count &= tc->tc_counter_mask;
-	tc->tc_offset_nano += (u_int64_t)delta * tc->tc_scale_nano_f;
-	tc->tc_offset_nano += (u_int64_t)delta * tc->tc_scale_nano_i << 32;
-	return (tc);
-}
-
-static void
-tco_forward(int force)
-{
-	struct timecounter *tc, *tco;
-	struct timeval tvt;
-
-	tco = timecounter;
-	tc = sync_other_counter();
-	/*
-	 * We may be inducing a tiny error here, the tc_poll_pps() may
-	 * process a latched count which happens after the tco_delta()
-	 * in sync_other_counter(), which would extend the previous
-	 * counters parameters into the domain of this new one.
-	 * Since the timewindow is very small for this, the error is
-	 * going to be only a few weenieseconds (as Dave Mills would
-	 * say), so lets just not talk more about it, OK ?
-	 */
-	if (tco->tc_poll_pps) 
-		tco->tc_poll_pps(tco);
-	if (timedelta != 0) {
-		tvt = boottime;
-		tvt.tv_usec += tickdelta;
-		if (tvt.tv_usec >= 1000000) {
-			tvt.tv_sec++;
-			tvt.tv_usec -= 1000000;
-		} else if (tvt.tv_usec < 0) {
-			tvt.tv_sec--;
-			tvt.tv_usec += 1000000;
-		}
-		boottime = tvt;
-		timedelta -= tickdelta;
-	}
-
-	while (tc->tc_offset_nano >= 1000000000ULL << 32) {
-		tc->tc_offset_nano -= 1000000000ULL << 32;
-		tc->tc_offset_sec++;
-		ntp_update_second(tc);	/* XXX only needed if xntpd runs */
-		tco_setscales(tc);
-		force++;
-	}
-
-	if (tco_method && !force)
-		return;
+	struct globaldata *gd = mycpu;
+	sysclock_t delta;
 
-	tc->tc_offset_micro = (tc->tc_offset_nano / 1000) >> 32;
+	do {
+		tsp->tv_sec = gd->gd_time_seconds;
+		delta = cputimer_count() - gd->gd_cpuclock_base;
+	} while (tsp->tv_sec != gd->gd_time_seconds);
+	tsp->tv_nsec = (cputimer_freq64_nsec * delta) >> 32;
 
-	/* Figure out the wall-clock time */
-	tc->tc_nanotime.tv_sec = tc->tc_offset_sec + boottime.tv_sec;
-	tc->tc_nanotime.tv_nsec = 
-	    (tc->tc_offset_nano >> 32) + boottime.tv_usec * 1000;
-	tc->tc_microtime.tv_usec = tc->tc_offset_micro + boottime.tv_usec;
-	while (tc->tc_nanotime.tv_nsec >= 1000000000) {
-		tc->tc_nanotime.tv_nsec -= 1000000000;
-		tc->tc_microtime.tv_usec -= 1000000;
-		tc->tc_nanotime.tv_sec++;
+	tsp->tv_sec += basetime.tv_sec;
+	tsp->tv_nsec += basetime.tv_nsec;
+	while (tsp->tv_nsec >= 1000000000) {
+		tsp->tv_nsec -= 1000000000;
+		++tsp->tv_sec;
 	}
-	time_second = tc->tc_microtime.tv_sec = tc->tc_nanotime.tv_sec;
-
-	timecounter = tc;
 }
 
-SYSCTL_NODE(_kern, OID_AUTO, timecounter, CTLFLAG_RW, 0, "");
-
-SYSCTL_INT(_kern_timecounter, OID_AUTO, method, CTLFLAG_RW, &tco_method, 0,
-    "This variable determines the method used for updating timecounters. "
-    "If the default algorithm (0) fails with \"calcru negative...\" messages "
-    "try the alternate algorithm (1) which handles bad hardware better."
-
-);
-
-static int
-sysctl_kern_timecounter_hardware(SYSCTL_HANDLER_ARGS)
-{
-	char newname[32];
-	struct timecounter *newtc, *tc;
-	int error;
-
-	tc = timecounter->tc_tweak;
-	strncpy(newname, tc->tc_name, sizeof(newname));
-	error = sysctl_handle_string(oidp, &newname[0], sizeof(newname), req);
-	if (error == 0 && req->newptr != NULL &&
-	    strcmp(newname, tc->tc_name) != 0) {
-		for (newtc = tc->tc_avail; newtc != tc;
-		    newtc = newtc->tc_avail) {
-			if (strcmp(newname, newtc->tc_name) == 0) {
-				/* Warm up new timecounter. */
-				(void)newtc->tc_get_timecount(newtc);
-
-				switch_timecounter(newtc);
-				return (0);
-			}
-		}
-		return (EINVAL);
-	}
-	return (error);
-}
-
-SYSCTL_PROC(_kern_timecounter, OID_AUTO, hardware, CTLTYPE_STRING | CTLFLAG_RW,
-    0, 0, sysctl_kern_timecounter_hardware, "A", "");
-
-
 int
 pps_ioctl(u_long cmd, caddr_t data, struct pps_state *pps)
 {
@@ -1031,13 +833,22 @@
 }
 
 void
-pps_event(struct pps_state *pps, struct timecounter *tc, unsigned count, int event)
+pps_event(struct pps_state *pps, sysclock_t count, int event)
 {
-	struct timespec ts, *tsp, *osp;
-	u_int64_t delta;
-	unsigned tcount, *pcount;
-	int foff, fhard;
-	pps_seq_t	*pseq;
+	struct globaldata *gd;
+	struct timespec *tsp;
+	struct timespec *osp;
+	struct timespec ts;
+	sysclock_t *pcount;
+#ifdef PPS_SYNC
+	sysclock_t tcount;
+#endif
+	sysclock_t delta;
+	pps_seq_t *pseq;
+	int foff;
+	int fhard;
+
+	gd = mycpu;
 
 	/* Things would be easier with arrays... */
 	if (event == PPS_CAPTUREASSERT) {
@@ -1056,36 +867,27 @@
 		pseq = &pps->ppsinfo.clear_sequence;
 	}
 
-	/* The timecounter changed: bail */
-	if (!pps->ppstc || 
-	    pps->ppstc->tc_name != tc->tc_name || 
-	    tc->tc_name != timecounter->tc_name) {
-		pps->ppstc = tc;
-		*pcount = count;
-		return;
-	}
-
 	/* Nothing really happened */
 	if (*pcount == count)
 		return;
 
 	*pcount = count;
 
-	/* Convert the count to timespec */
-	ts.tv_sec = tc->tc_offset_sec;
-	tcount = count - tc->tc_offset_count;
-	tcount &= tc->tc_counter_mask;
-	delta = tc->tc_offset_nano;
-	delta += ((u_int64_t)tcount * tc->tc_scale_nano_f);
-	delta >>= 32;
-	delta += ((u_int64_t)tcount * tc->tc_scale_nano_i);
-	delta += boottime.tv_usec * 1000;
-	ts.tv_sec += boottime.tv_sec;
-	while (delta >= 1000000000) {
-		delta -= 1000000000;
-		ts.tv_sec++;
+	do {
+		ts.tv_sec = gd->gd_time_seconds;
+		delta = count - gd->gd_cpuclock_base;
+	} while (ts.tv_sec != gd->gd_time_seconds);
+	if (delta > cputimer_freq) {
+		ts.tv_sec += delta / cputimer_freq;
+		delta %= cputimer_freq;
+	}
+	ts.tv_nsec = (cputimer_freq64_nsec * delta) >> 32;
+	ts.tv_sec += basetime.tv_sec;
+	ts.tv_nsec += basetime.tv_nsec;
+	while (ts.tv_nsec >= 1000000000) {
+		ts.tv_nsec -= 1000000000;
+		++ts.tv_sec;
 	}
-	ts.tv_nsec = delta;
 
 	(*pseq)++;
 	*tsp = ts;
@@ -1102,11 +904,9 @@
 		/* magic, at its best... */
 		tcount = count - pps->ppscount[2];
 		pps->ppscount[2] = count;
-		tcount &= tc->tc_counter_mask;
-		delta = ((u_int64_t)tcount * tc->tc_tweak->tc_scale_nano_f);
-		delta >>= 32;
-		delta += ((u_int64_t)tcount * tc->tc_tweak->tc_scale_nano_i);
+		delta = (cputimer_freq64_nsec * tcount) >> 32;
 		hardpps(tsp, delta);
 	}
 #endif
 }
+
Index: kern/kern_ntptime.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_ntptime.c,v
retrieving revision 1.7
diff -u -r1.7 kern_ntptime.c
--- kern/kern_ntptime.c	30 Jul 2003 00:19:14 -0000	1.7
+++ kern/kern_ntptime.c	27 Jan 2004 01:28:49 -0000
@@ -43,6 +43,7 @@
 #include <sys/timex.h>
 #include <sys/timepps.h>
 #include <sys/sysctl.h>
+#include <sys/thread2.h>
 
 /*
  * Single-precision macros for 64-bit machines
@@ -271,7 +272,6 @@
 	struct timex ntv;	/* temporary structure */
 	long freq;		/* frequency ns/s) */
 	int modes;		/* mode bits from structure */
-	int s;			/* caller priority */
 	int error;
 
 	error = copyin((caddr_t)uap->tp, (caddr_t)&ntv, sizeof(ntv));
@@ -292,7 +292,7 @@
 		error = suser(td);
 	if (error)
 		return (error);
-	s = splclock();
+	crit_enter();
 	if (modes & MOD_MAXERROR)
 		time_maxerror = ntv.maxerror;
 	if (modes & MOD_ESTERROR)
@@ -344,6 +344,11 @@
 		else
 			hardupdate(ntv.offset * 1000);
 	}
+	/*
+	 * Note: the userland specified frequency is in seconds per second
+	 * times 65536e+6.  Multiply by a thousand and divide by 65336 to
+	 * get nanoseconds.
+	 */
 	if (modes & MOD_FREQUENCY) {
 		freq = (ntv.freq * 1000LL) >> 16;
 		if (freq > MAXFREQ)
@@ -388,7 +393,7 @@
 	ntv.jitcnt = pps_jitcnt;
 	ntv.stbcnt = pps_stbcnt;
 #endif /* PPS_SYNC */
-	splx(s);
+	crit_exit();
 
 	error = copyout((caddr_t)&ntv, (caddr_t)uap->tp, sizeof(ntv));
 	if (error)
@@ -415,18 +420,16 @@
 /*
  * second_overflow() - called after ntp_tick_adjust()
  *
- * This routine is ordinarily called immediately following the above
- * routine ntp_tick_adjust(). While these two routines are normally
- * combined, they are separated here only for the purposes of
- * simulation.
+ * This routine is ordinarily called from hardclock() whenever the seconds
+ * hand rolls over.  It returns leap seconds to add or drop, and sets nsec_adj
+ * to the total adjustment to make over the next second in (ns << 32).
  */
-void
-ntp_update_second(struct timecounter *tcp)
+int
+ntp_update_second(time_t newsec, int64_t *nsec_adj)
 {
-	u_int32_t *newsec;
 	l_fp ftemp;		/* 32/64-bit temporary */
+	int  adjsec = 0;
 
-	newsec = &tcp->tc_offset_sec;
 	/*
 	 * On rollover of the second both the nanosecond and microsecond
 	 * clocks are updated and the state machine cranked as
@@ -463,8 +466,8 @@
 		case TIME_INS:
 		if (!(time_status & STA_INS))
 			time_state = TIME_OK;
-		else if ((*newsec) % 86400 == 0) {
-			(*newsec)--;
+		else if ((newsec) % 86400 == 0) {
+			--adjsec;
 			time_state = TIME_OOP;
 		}
 		break;
@@ -475,8 +478,8 @@
 		case TIME_DEL:
 		if (!(time_status & STA_DEL))
 			time_state = TIME_OK;
-		else if (((*newsec) + 1) % 86400 == 0) {
-			(*newsec)++;
+		else if (((newsec) + 1) % 86400 == 0) {
+			++adjsec;
 			time_tai--;
 			time_state = TIME_WAIT;
 		}
@@ -499,33 +502,35 @@
 	}
 
 	/*
-	 * Compute the total time adjustment for the next second
-	 * in ns. The offset is reduced by a factor depending on
-	 * whether the PPS signal is operating. Note that the
-	 * value is in effect scaled by the clock frequency,
-	 * since the adjustment is added at each tick interrupt.
+	 * time_offset represents the total time adjustment we wish to
+	 * make (over no particular period of time).  time_freq represents
+	 * the frequency compensation we wish to apply.
+	 *
+	 * time_adj represents the total adjustment we wish to make over
+	 * one full second.  hardclock usually applies this adjustment in
+	 * time_adj / hz jumps, hz times a second.
 	 */
 	ftemp = time_offset;
 #ifdef PPS_SYNC
 	/* XXX even if PPS signal dies we should finish adjustment ? */
-	if (time_status & STA_PPSTIME && time_status &
-	    STA_PPSSIGNAL)
+	if ((time_status & STA_PPSTIME( && (time_status & STA_PPSSIGNAL))
 		L_RSHIFT(ftemp, pps_shift);
 	else
 		L_RSHIFT(ftemp, SHIFT_PLL + time_constant);
 #else
 		L_RSHIFT(ftemp, SHIFT_PLL + time_constant);
 #endif /* PPS_SYNC */
-	time_adj = ftemp;
+	time_adj = ftemp;		/* adjustment for part of the offset */
 	L_SUB(time_offset, ftemp);
-	L_ADD(time_adj, time_freq);
-	tcp->tc_adjustment = time_adj;
+	L_ADD(time_adj, time_freq);	/* add frequency correction */
+	*nsec_adj = time_adj;
 #ifdef PPS_SYNC
 	if (pps_valid > 0)
 		pps_valid--;
 	else
 		time_status &= ~STA_PPSSIGNAL;
 #endif /* PPS_SYNC */
+	return(adjsec);
 }
 
 /*
@@ -594,6 +599,9 @@
 {
 	long mtemp;
 	l_fp ftemp;
+	globaldata_t gd;
+
+	gd = mycpu;
 
 	/*
 	 * Select how the phase is to be controlled and from which
@@ -603,8 +611,7 @@
 	 */
 	if (!(time_status & STA_PLL))
 		return;
-	if (!(time_status & STA_PPSTIME && time_status &
-	    STA_PPSSIGNAL)) {
+	if (!((time_status & STA_PPSTIME) && (time_status & STA_PPSSIGNAL))) {
 		if (offset > MAXPHASE)
 			time_monitor = MAXPHASE;
 		else if (offset < -MAXPHASE)
@@ -619,6 +626,9 @@
 	 * mode (PLL or FLL). If the PPS signal is present and enabled
 	 * to discipline the frequency, the PPS frequency is used;
 	 * otherwise, the argument offset is used to compute it.
+	 *
+	 * gd_time_seconds is basically an uncompensated uptime.  We use
+	 * this for consistency.
 	 */
 	if (time_status & STA_PPSFREQ && time_status & STA_PPSSIGNAL) {
 		time_reftime = time_second;
@@ -632,8 +642,7 @@
 	L_MPY(ftemp, mtemp);
 	L_ADD(time_freq, ftemp);
 	time_status &= ~STA_MODE;
-	if (mtemp >= MINSEC && (time_status & STA_FLL || mtemp >
-	    MAXSEC)) {
+	if (mtemp >= MINSEC && (time_status & STA_FLL || mtemp > MAXSEC)) {
 		L_LINT(ftemp, (time_monitor << 4) / mtemp);
 		L_RSHIFT(ftemp, SHIFT_FLL + 4);
 		L_ADD(time_freq, ftemp);
Index: kern/kern_poll.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_poll.c,v
retrieving revision 1.6
diff -u -r1.6 kern_poll.c
--- kern/kern_poll.c	8 Nov 2003 07:57:41 -0000	1.6
+++ kern/kern_poll.c	25 Jan 2004 08:08:07 -0000
@@ -201,6 +201,8 @@
  * The first part of the code is just for debugging purposes, and tries
  * to count how often hardclock ticks are shorter than they should,
  * meaning either stray interrupts or delayed events.
+ *
+ * WARNING! called from fastint or IPI, the MP lock might not be held.
  */
 void
 hardclock_device_poll(void)
Index: kern/kern_random.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_random.c,v
retrieving revision 1.5
diff -u -r1.5 kern_random.c
--- kern/kern_random.c	29 Jul 2003 21:30:02 -0000	1.5
+++ kern/kern_random.c	25 Jan 2004 08:27:46 -0000
@@ -47,6 +47,7 @@
 #include <sys/random.h>
 #include <sys/select.h>
 #include <sys/systm.h>
+#include <sys/systimer.h>
 
 #ifdef __i386__
 #include <i386/isa/icu.h>
@@ -191,10 +192,8 @@
 	int		delta, delta2;
 	u_int		nbits;
 	u_int32_t	time;
-	struct timecounter *tc;
 
-	tc = timecounter;
-	num ^= tc->tc_get_timecount(tc) << 16;
+	num ^= cputimer_count() << 16;
 	r->entropy_count += 2;
 		
 	time = ticks;
Index: kern/kern_synch.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_synch.c,v
retrieving revision 1.26
diff -u -r1.26 kern_synch.c
--- kern/kern_synch.c	7 Jan 2004 11:04:18 -0000	1.26
+++ kern/kern_synch.c	25 Jan 2004 08:03:39 -0000
@@ -161,7 +161,7 @@
  *          Note that, as ps(1) mentions, this can let percentages
  *          total over 100% (I've seen 137.9% for 3 processes).
  *
- * Note that schedclock() updates p_estcpu and p_cpticks asynchronously.
+ * Note that schedulerclock() updates p_estcpu and p_cpticks asynchronously.
  *
  * We wish to decay away 90% of p_estcpu in (5 * loadavg) seconds.
  * That is, the system wants to compute a value of decay such
@@ -871,10 +871,11 @@
  * time in 5 * loadav seconds.  This causes the system to favor processes
  * which haven't run much recently, and to round-robin among other processes.
  *
- * WARNING!
+ * WARNING! called from a fast-int or an IPI, the MP lock MIGHT NOT BE HELD
+ * and we cannot block.
  */
 void
-schedclock(void *dummy)
+schedulerclock(void *dummy)
 {
 	struct thread *td;
 	struct proc *p;
Index: kern/kern_systimer.c
===================================================================
RCS file: kern/kern_systimer.c
diff -N kern/kern_systimer.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ kern/kern_systimer.c	27 Jan 2004 23:54:04 -0000
@@ -0,0 +1,207 @@
+/*
+ * Copyright (c) 2003 Matthew Dillon <dillon@backplane.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $DragonFly$
+ */
+
+/*
+ * This code implements a fine-grained per-cpu system timer which is
+ * ultimately based on a hardware timer.  The hardware timer abstraction
+ * is sufficiently disconnected from this code to support both per-cpu
+ * hardware timers or a single system-wide hardware timer.
+ *
+ * Notes on machine-dependant code (in arch/arch/systimer.c)
+ *
+ * cputimer_intr_reload()	Reload the one-shot (per-cpu basis)
+ *
+ * cputimer_count()		Get the current absolute sysclock_t value.
+ */
+
+#include <sys/param.h>
+#include <sys/kernel.h>
+#include <sys/systm.h>
+#include <sys/thread.h>
+#include <sys/globaldata.h>
+#include <sys/systimer.h>
+#include <sys/thread2.h>
+
+/*
+ * Execute ready systimers.  Called directly from the platform-specific
+ * one-shot timer clock interrupt (e.g. clkintr()).  Systimer functions are
+ * responsible for calling hardclock, statclock, and other finely-timed
+ * routines.
+ */
+void
+systimer_intr(sysclock_t *timep, struct intrframe *frame)
+{
+    globaldata_t gd = mycpu;
+    sysclock_t time = *timep;
+    systimer_t info;
+
+    if (gd->gd_syst_nest)
+	return;
+
+    crit_enter();
+    ++gd->gd_syst_nest;
+    while ((info = TAILQ_FIRST(&gd->gd_systimerq)) != NULL) {
+	/*
+	 * If we haven't reached the requested time, tell the cputimer
+	 * how much is left and break out.
+	 */
+	if ((int)(info->time - time) > 0) {
+	    cputimer_intr_reload(info->time - time);
+	    break;
+	}
+
+	/*
+	 * Dequeue and execute
+	 */
+	info->flags &= ~SYSTF_ONQUEUE;
+	TAILQ_REMOVE(info->queue, info, node);
+	crit_exit();
+	info->func(info, frame);
+	crit_enter();
+
+	/*
+	 * Reinstall if periodic
+	 */
+	if (info->periodic) {
+	    info->time += info->periodic;
+	    systimer_add(info);
+	}
+    }
+    if (info)
+	gd->gd_nextclock = info->time;
+    else
+	gd->gd_nextclock = 0;
+    --gd->gd_syst_nest;
+    crit_exit();
+}
+
+void
+systimer_add(systimer_t info)
+{
+    struct globaldata *gd = mycpu;
+
+    KKASSERT((info->flags & (SYSTF_ONQUEUE|SYSTF_IPIRUNNING)) == 0);
+    crit_enter();
+    if (info->gd == gd) {
+	systimer_t scan1;
+	systimer_t scan2;
+	scan1 = TAILQ_FIRST(&gd->gd_systimerq);
+	if (scan1 == NULL || (int)(scan1->time - info->time) > 0) {
+	    gd->gd_nextclock = info->time;
+	    cputimer_intr_reload(info->time - cputimer_count());
+	    TAILQ_INSERT_HEAD(&gd->gd_systimerq, info, node);
+	} else {
+	    scan2 = TAILQ_LAST(&gd->gd_systimerq, systimerq);
+	    for (;;) {
+		if (scan1 == NULL) {
+		    TAILQ_INSERT_TAIL(&gd->gd_systimerq, info, node);
+		    break;
+		}
+		if ((int)(scan1->time - info->time) > 0) {
+		    TAILQ_INSERT_BEFORE(scan1, info, node);
+		    break;
+		}
+		if ((int)(scan2->time - info->time) <= 0) {
+		    TAILQ_INSERT_AFTER(&gd->gd_systimerq, scan2, info, node);
+		    break;
+		}
+		scan1 = TAILQ_NEXT(scan1, node);
+		scan2 = TAILQ_PREV(scan2, systimerq, node);
+	    }
+	}
+	info->flags = (info->flags | SYSTF_ONQUEUE) & ~SYSTF_IPIRUNNING;
+	info->queue = &gd->gd_systimerq;
+    } else {
+	info->flags |= SYSTF_IPIRUNNING;
+	lwkt_send_ipiq(info->gd->gd_cpuid, (ipifunc_t)systimer_add, info);
+    }
+    crit_exit();
+}
+
+/*
+ * systimer_del()
+ *
+ *	Delete a system timer.  Only the owning cpu can delete a timer.
+ */
+void
+systimer_del(systimer_t info)
+{
+    KKASSERT(info->gd == mycpu && (info->flags & SYSTF_IPIRUNNING) == 0);
+    crit_enter();
+    if (info->flags & SYSTF_ONQUEUE) {
+	TAILQ_REMOVE(info->queue, info, node);
+	info->flags &= ~SYSTF_ONQUEUE;
+    }
+    crit_exit();
+}
+
+/*
+ * systimer_init_periodic()
+ *
+ *	Initialize a periodic timer at the specified frequency and add
+ *	it to the system.  The frequency is uncompensated and approximate.
+ *
+ *	Try to synchronize multi registrations of the same or similar
+ *	frequencies so the hardware interrupt is able to dispatch several
+ *	at together by adjusting the phase of the initial interrupt.  This
+ *	helps SMP.  Note that we are not attempting to synchronize to 
+ *	the realtime clock.
+ */
+void
+systimer_init_periodic(systimer_t info, void *func, void *data, int hz)
+{
+    sysclock_t base_count;
+
+    bzero(info, sizeof(struct systimer));
+    info->periodic = cputimer_fromhz(hz);
+    base_count = cputimer_count();
+    base_count = base_count - (base_count % info->periodic);
+    info->time = base_count + info->periodic;
+    info->func = func;
+    info->data = data;
+    info->gd = mycpu;
+    systimer_add(info);
+}
+
+/*
+ * systimer_init_oneshot()
+ *
+ *	Initialize a periodic timer at the specified frequency and add
+ *	it to the system.  The frequency is uncompensated and approximate.
+ */
+void
+systimer_init_oneshot(systimer_t info, void *func, void *data, int us)
+{
+    bzero(info, sizeof(struct systimer));
+    info->time = cputimer_count() + cputimer_fromus(us);
+    info->func = func;
+    info->data = data;
+    info->gd = mycpu;
+    systimer_add(info);
+}
+
